Subject: Re: bug#42761: 28.0.50; [feature/native-comp] allow customizing command line/driver options?

From: Andreas Fuchs <[email-masked]>
Date: Mon, 10 Aug 2020 22:34:03 -0400

On Sun, Aug 9, 2020 at 3:58 AM Andrea Corallo <[email-masked]> wrote:
> From the patch:
> > + #ifdef LIBGCCJIT_HAVE_gcc_jit_context_add_command_line_option
> > + DEF_DLL_FN (void, gcc_jit_context_add_driver_option,
> > +             (gcc_jit_context *ctxt, const char *optname));
> > + #endif
> [...]
> > + #ifdef LIBGCCJIT_HAVE_gcc_jit_context_add_command_line_option
> > +   LOAD_DLL_FN (library, gcc_jit_context_add_driver_option);
> > + #endif
>
> The above should not be ifdef'd as they allow the function to be used
> only if present in the library in use at runtime on Windows systems.
>
> Unfortunatelly we do not have such system for Linux where the decision
> to include the call is done at compile time.  So unless we implement
> that too also the call site has to be a little changed to handle this.
>
> Please have a look for that into in Fcomp_libgccjit_version where we use
> gcc_jit_version_*.  These are the only "optional" libgccjit entry point
> we used so far.

Ah, I misread the #ifdef condition above those. Makes sense, I've adjusted
the branch and added one more commit that should ensure we pass the
`comp-native-driver-options' to async compilation child processes
correctly.

This patch builds on my system, builds on darwin under nix (with some
additional changes to emit "-L" library path entries), and asynchronously
compiles code, too!

Cheers,
-- 
Andreas Fuchs, (http://|im:asf@|mailto:asf@)boinkor.net, antifuchs